    .586                        ; create 32 bit code
    .model flat, stdcall        ; 32 bit memory model
    option casemap :none        ; case sensitive

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\msvcrt.lib

    include \masm32\macros\macros.asm

    include timers.asm

    LOOP_COUNT equ 50000

    MAXSIZE equ   8
    MAXTERM equ 300

    bcd$ MACRO DDpointer,DDsize
      LOCAL rvstring
      .data
        rvstring db 8*MAXSIZE+4 dup (0)
        align 4
      .code
      push esi
      push edi
      push ebx
      mov edi,offset rvstring
      mov esi,DDpointer
      mov ebx,DDsize
      dec ebx
@@:   mov eax,[esi+4*ebx]
      invoke dw2hex,eax,edi
      add edi,8
      dec ebx
      jns @B
      pop ebx
      pop edi
      pop esi
      EXITM <ADDR rvstring>
    ENDM

    .data

ddsize  dd MAXSIZE

    .data?

maxterm dd ?
wksize  dd ?
pLast   dd ?
source  dd MAXSIZE dup(?)
destin  dd MAXSIZE dup(?)

    .code

include bcdadd.asm
include bcdtesta.asm
include bcdtestb.asm

start:

    counter_begin LOOP_COUNT, NORMAL_PRIORITY_CLASS
        mov esi,offset source
        mov edi, offset destin
        mov maxterm,MAXTERM
        mov dword ptr wksize,1
        mov dword ptr [esi],1
        mov dword ptr [edi],0
@@:     push    esi
        push    edi
        call    AddBCD
        pop     esi
        pop     edi
        jc      @F
        dec     maxterm
        jnz     @B
@@:     mov     pLast,edi
    counter_end

    print ustr$(eax)
    print chr$(" AddBCD: ")
    print bcd$(pLast,wksize)
    print chr$(13,10)

    counter_begin LOOP_COUNT, NORMAL_PRIORITY_CLASS
        mov esi,offset source
        mov edi, offset destin
        mov maxterm,MAXTERM
        mov dword ptr wksize,1
        mov dword ptr [esi],1
        mov dword ptr [edi],0
@@:     push    esi
        push    edi
        call    TestA
        pop     esi
        pop     edi
        jc      @F
        dec     maxterm
        jnz     @B
@@:     mov     pLast,edi
    counter_end

    print ustr$(eax)
    print chr$(" Test A: ")
    print bcd$(pLast,wksize)
    print chr$(13,10)

    counter_begin LOOP_COUNT, NORMAL_PRIORITY_CLASS
        mov esi,offset source
        mov edi, offset destin
        mov maxterm,MAXTERM
        mov dword ptr wksize,1
        mov dword ptr [esi],1
        mov dword ptr [edi],0
@@:     push    esi
        push    edi
        call    TestB
        pop     esi
        pop     edi
        jc      @F
        dec     maxterm
        jnz     @B
@@:     mov     pLast,edi
    counter_end

    print ustr$(eax)
    print chr$(" Test B: ")
    print bcd$(pLast,wksize)
    print chr$(13,10)

    mov   eax, input(13,10,"Press enter to exit...")
    exit

end start
